import { MeasurementUnit, Paging } from "entity";
import { NextFunction, Response } from "express";
import { Request } from "express-jwt";
import Joi from "joi";
import { ILogObj, Logger } from "tslog";
import CommonHelper from "../helpers/common";
import { ReturnHelper } from "../helpers/express/return";
import { Language } from "../langs/lang";
import { MeasurementUnitModel } from "../model/measurement_unit";
import { OrmHelper } from "../helpers/orm";
import moment from "moment";

const log: Logger<ILogObj> = new Logger({
	name: "[MeasurementUnitController]",
	type: "pretty",
});

export class MeasurementUnitController {
	static async list(req: Request, res: Response, next: NextFunction): Promise<void | Response> {
		/*
            #swagger.tags = ['Measurement Unit']
            #swagger.security = [{ "bearerAuth": [] }]
            #swagger.parameters['filter'] = { description: 'Filter: plain text or JSON object (status, unit, etc.)', in: 'query', type: 'string' }
            #swagger.parameters['limit'] = { in: 'query', required: true, type: 'number' }
            #swagger.parameters['page'] = { in: 'query', required: true, type: 'number' }
            #swagger.parameters['with_deleted'] = { in: 'query', required: true, type: 'boolean' }
            #swagger.parameters['order_field'] = { in: 'query', required: true, type: 'string' }
            #swagger.parameters['order_direction'] = { in: 'query', required: true, schema: { '@enum': ['ASC', 'DESC'] } }
        */
		try {
			const schema = Joi.object().keys({
				filter: Joi.string().allow("").optional().label("Filter"),
				page: Joi.number().required().min(1).label("Page"),
				limit: Joi.number().required().min(1).label("Limit"),
				with_deleted: Joi.bool().required().label("With Deleted"),
				order_field: Joi.string().required().label("Order Field"),
				order_direction: Joi.string().allow("asc", "desc").required().label("Order Direction"),
			});

			let param: Paging = await schema.validateAsync(req.query);

			let filter = param.filter && param.filter !== "" ? JSON.parse(param.filter) : {};

			var query = await MeasurementUnitModel.list(filter);

			const offset = (param.page - 1) * param.limit;
			let limit = param.limit;

			const res_count = query;
			const res_list = query
				.orderBy("MeasurementUnit." + param.order_field, param.order_direction)
				.offset(offset)
				.limit(limit);

			if (param.with_deleted) {
				res_count.withDeleted();
				res_list.withDeleted();
			}

			const current_page = param.page;
			const total_count_data = await res_count.getCount();
			const list_data = await res_list.getMany();
			const count_data = CommonHelper.countObject(list_data);

			return ReturnHelper.successResponselist(res, 200, Language.lang.success_view, count_data, current_page, total_count_data, list_data);
		} catch (e: unknown) {
			log.error(e);
			const err = e as Error;
			return ReturnHelper.errorResponse(res, 400, 401, Language.lang.failed_view, err.message);
		}
	}

	static async create(req: Request, res: Response, next: NextFunction): Promise<void | Response> {
		/*
         #swagger.tags = ['Measurement Unit']
         #swagger.security = [{ "bearerAuth": [] }]
         #swagger.requestBody = { required: true, content: { "application/json": { schema: { $ref: "#/components/schemas/measurementUnit" } } } }
         */
		const queryRunner = OrmHelper.DB.createQueryRunner();
		await queryRunner.startTransaction();
		try {
			const schema = Joi.object().keys({
				unit: Joi.string().max(256).required().label("Unit"),
				status: Joi.string().required().label("Status"),
			});

			let param: any = await schema.validateAsync(req.body);

			let filter = { unit: param.unit };
			let exist = await MeasurementUnitModel.list(filter).then((q) => q.getOne());
			if (exist) throw { message: "Measurement Unit " + Language.lang.failed_duplicate };

			let measurementUnit = new MeasurementUnit();
			measurementUnit.unit = param.unit;
			measurementUnit.status = param.status;
			measurementUnit.created_by = req.auth.data.name;
			measurementUnit.updated_by = req.auth.data.name;
			await queryRunner.manager.save(measurementUnit);

			await queryRunner.commitTransaction();

			return ReturnHelper.successResponseAny(res, 200, Language.lang.success_insert, measurementUnit);
		} catch (e: unknown) {
			await queryRunner.rollbackTransaction();
			log.error(e);
			const err = e as Error;
			return ReturnHelper.errorResponse(res, 400, 401, Language.lang.failed_view, err.message);
		} finally {
			await queryRunner.release();
		}
	}

	static async detail(req: Request, res: Response, next: NextFunction): Promise<void | Response> {
		/*
         #swagger.tags = ['Measurement Unit']
         #swagger.security = [{ "bearerAuth": [] }]
         #swagger.parameters['id'] = { in: 'path', type: 'string' }
        */
		try {
			const schema = Joi.object().keys({
				id: Joi.string().uuid().required().label("Measurement Unit Id"),
			});

			let param: any = await schema.validateAsync(req.params);

			let measurementUnit = await MeasurementUnitModel.list({ "MeasurementUnit.id": param.id }).then((q) => q.getOne());

			if (!measurementUnit) throw { message: "Measurement Unit Not Found" };

			return ReturnHelper.successResponseAny(res, 200, Language.lang.success_view, measurementUnit);
		} catch (e: unknown) {
			log.error(e);
			const err = e as Error;
			return ReturnHelper.errorResponse(res, 400, 401, Language.lang.failed_not_found, err.message);
		}
	}

	static async update(req: Request, res: Response, next: NextFunction): Promise<void | Response> {
		/*
         #swagger.tags = ['Measurement Unit']
         #swagger.security = [{ "bearerAuth": [] }]
         #swagger.parameters['id'] = { in: 'path', type: 'string' }
         #swagger.requestBody = { required: true, content: { "application/json": { schema: { $ref: "#/components/schemas/measurementUnit" } } } }
         */
		const queryRunner = OrmHelper.DB.createQueryRunner();
		await queryRunner.startTransaction();

		try {
			req.body.id = req.params["id"];

			const schema = Joi.object().keys({
				id: Joi.string().uuid().required().label("Measurement Unit ID"),
				unit: Joi.string().max(256).required().label("Unit"),
				status: Joi.string().required().label("Status"),
			});

			let param: any = await schema.validateAsync(req.body);

			let filter = { unit: param.unit };
			let exist = await MeasurementUnitModel.list(filter).then((q) => q.getOne());
			if (exist && exist.id != param.id) throw { message: "Measurement Unit " + Language.lang.failed_duplicate };

			let measurementUnit = await MeasurementUnitModel.list({ "MeasurementUnit.id": param.id }).then((q) => q.getOne());

			if (!measurementUnit) throw { message: "Measurement Unit " + Language.lang.failed_not_found };

			measurementUnit.unit = param.unit;
			measurementUnit.status = param.status;
			measurementUnit.updated_by = req.auth.data.name;
			await queryRunner.manager.save(measurementUnit);

			await queryRunner.commitTransaction();

			return ReturnHelper.successResponseAny(res, 200, Language.lang.success_update, measurementUnit);
		} catch (e: unknown) {
			await queryRunner.rollbackTransaction();
			log.error(e);
			const err = e as Error;
			return ReturnHelper.errorResponse(res, 400, 401, Language.lang.failed_view, err.message);
		} finally {
			await queryRunner.release();
		}
	}

	static async delete(req: Request, res: Response, next: NextFunction): Promise<Response> {
		/*
        #swagger.tags = ['Measurement Unit']
        #swagger.security = [{ "bearerAuth": [] }]
        #swagger.parameters['id'] = { in: 'path', required: true, type: 'string' }
        #swagger.parameters['hard'] = { in: 'path', description: 'Is Hard Delete', required: false, type: 'boolean' }
        */
		try {
			const schema = Joi.object().keys({
				id: Joi.string().uuid().required().label("ID"),
				hard: Joi.bool().optional().allow("").label("Is hard delete?"),
			});

			const param: { id: string; hard: boolean } = await schema.validateAsync(req.params);

			let affected = 0;
			if (!param.hard) {
				let measurementUnit: MeasurementUnit = await MeasurementUnitModel.list({ "MeasurementUnit.id": param.id }).then((q) => q.getOne());

				if (!measurementUnit) throw { message: "Measurement Unit " + Language.lang.failed_not_found };

				measurementUnit.deleted_by = req.auth.data.name;
				measurementUnit.deleted_at = moment().toDate();
				await OrmHelper.DB.manager.save(measurementUnit);
				affected = 1;
			} else {
				const repo = OrmHelper.DB.getRepository(MeasurementUnit);
				affected = (await repo.delete({ id: param.id })).affected ?? 0;
			}

			if (affected > 0) {
				return ReturnHelper.successResponseAny(res, 200, Language.lang.success_delete, {});
			} else {
				return ReturnHelper.errorResponse(res, 404, 401, Language.lang.failed_not_found, "");
			}
		} catch (e: unknown) {
			log.error(e);
			const err = e as Error;
			return ReturnHelper.errorResponse(res, 500, 402, Language.lang.failed_delete, err.message);
		}
	}

	static async restore(req: Request, res: Response, next: NextFunction): Promise<Response> {
		/*
        #swagger.tags = ['Measurement Unit']
        #swagger.security = [{ "bearerAuth": [] }]
        #swagger.parameters['id'] = { in: 'path', required: true, type: 'string' }
        */
		try {
			const schema = Joi.object().keys({
				id: Joi.string().uuid().required().label("ID"),
			});

			const param: any = await schema.validateAsync(req.params);

			const repo = OrmHelper.DB.getRepository(MeasurementUnit);

			const affected = (await repo.restore({ id: param.id })).affected ?? 0;

			if (affected > 0) {
				return ReturnHelper.successResponseAny(res, 200, Language.lang.success_restore, {});
			} else {
				return ReturnHelper.errorResponse(res, 404, 401, Language.lang.failed_not_found, "");
			}
		} catch (e: unknown) {
			log.error(e);
			const err = e as Error;
			return ReturnHelper.errorResponse(res, 500, 402, Language.lang.failed_restore, err.message);
		}
	}
}
